/*
  Env_senseP1.c
  December 14, 2013 
*/
#include "simpletools.h"
#include "simpletext.h"
#include "fdserial.h"

#include "sRTC.h"


/* Auto sd_mount of SD. */
extern _Driver _NullDriver;
extern _Driver _FileDriver;

_Driver *_driverlist[] = {
  &_NullDriver,
  &_FileDriver,
  NULL
};

serial *xbee;
FILE *sp;

static volatile int logstat;

unsigned int sht11stack[40 + 25];  // 40 + 25
unsigned int sensestack[40 + 25];  // 40 + 25

void menu(void);

/* COG functions. */
void sht11(void* par);
void senselog(void* par);



int main()
{
  // Add startup code here.
/* Open a file for append. */
  if((sp=fopen("SenseD.txt","a"))==0)
  {
    while(1)
    {
      high(27);    // Red LED, error on open.
      pause(500);
      low(27);
      pause(500);
    }
  }
  else
  {
    high(26);  // Green LED, file was opened.
  }

/* Start the sht11 cog. */
  cogstart(&sht11, NULL, sht11stack, sizeof(sht11stack));
/* Start the senselog cog. */
  cogstart(&senselog, NULL, sensestack, sizeof(sensestack));
  pause(100);

/* Init the XBee module. */
/*                     Rx  Tx mode BAUD */
  xbee = fdserial_open(25, 24, 0, 9600);
  pause(50);
/* Start the Sensirion RTC. */
  sRTC_Start();
  sRTC_Update();
  sRTC_Set24hourmode(1);
  sRTC_Update();
  char inBuff[40];

  menu();
 
  while(1)
  {
    // Add main loop code here.
    writeStr(xbee,"> ");
    readStr(xbee, inBuff, 40);
    if(!strcmp(inBuff, "help")) menu();
    else if(!strcmp(inBuff,"testlog"))
    {
      logstat = 1;
    }
    else
    {
      writeLine(xbee,"Invalid Command!");
    }    
  }  
}

void menu()
{
  writeStr(xbee, "Menu - help, testlog \n");
}


void sht11(void* par)
{
  while(1)
  {
    pause(100);
  }
}


void senselog(void* par)
{
  int sostat;
  while(1)
  {
    sostat = logstat;
    if(sostat == 1)
    {
      //high(27);
      sp = fopen("SenseD.txt", "a");
      char outBuff[] = {' ',' '};
      int day, month, year;
      sRTC_Update();
      month = sRTC_Getmonth();
      sprint(outBuff,"%d",month);
      fwrite(outBuff,1,2,sp);
      fwrite("/",1,1,sp);
      fclose(sp);
      //low(27);
      logstat = 0;
    }
    pause(250);
  }
}
